; RUN: opt < %s -passes="print<cost-model>" 2>&1 -disable-output -mtriple=systemz-unknown -mcpu=z13 | FileCheck %s
;
; Test costs for i8 and i16 comparisons against memory with a small immediate.

define i32 @fun0(ptr %Src, ptr %Dst, i8 %Val) {
; CHECK: function 'fun0'
; CHECK: Cost Model: Found an estimated cost of 0 for instruction:   %Ld = load i8, ptr %Src
; CHECK: Cost Model: Found an estimated cost of 1 for instruction:   %Cmp = icmp eq i8 %Ld, 123
; CHECK: Cost Model: Found an estimated cost of 2 for instruction:   %Ret = zext i1 %Cmp to i32
; CHECK: Cost Model: Found an estimated cost of 1 for instruction:   ret i32 %Ret
  %Ld = load i8, ptr %Src
  %Cmp = icmp eq i8 %Ld, 123
  %Ret = zext i1 %Cmp to i32
  ret i32 %Ret
}

define i32 @fun1(ptr %Src, ptr %Dst, i16 %Val) {
; CHECK: function 'fun1'
; CHECK: Cost Model: Found an estimated cost of 0 for instruction:   %Ld = load i16, ptr %Src
; CHECK: Cost Model: Found an estimated cost of 1 for instruction:   %Cmp = icmp eq i16
; CHECK: Cost Model: Found an estimated cost of 2 for instruction:   %Ret = zext i1 %Cmp to i32
; CHECK: Cost Model: Found an estimated cost of 1 for instruction:   ret i32 %Ret
  %Ld = load i16, ptr %Src
  %Cmp = icmp eq i16 %Ld, 1234
  %Ret = zext i1 %Cmp to i32
  ret i32 %Ret
}
